package de.steamwar.lobby.particle.elements;

import de.steamwar.lobby.particle.ParticleElement;
import de.steamwar.lobby.particle.ParticleTickData;
import de.steamwar.lobby.particle.ParticleTickType;
import org.bukkit.Location;
import org.bukkit.util.Vector;

public class DoubleCircle extends Circle {

    private ParticleElement second;

    private double distance;
    private double speed;

    public DoubleCircle(ParticleElement first, ParticleElement second) {
        super(first);
        this.second = second;
        this.distance = 1;
        this.speed = 1;
    }

    public DoubleCircle(ParticleElement first, ParticleElement second, double distance, double speed) {
        super(first);
        this.second = second;
        this.distance = distance;
        this.speed = speed;
    }

    @Override
    public String attribute() {
        return "PARTICLE_ATTRIBUTE_BI_CIRCLE";
    }

    @Override
    public ParticleTickType tickType() {
        if (particleElement.tickType() == second.tickType()) {
            return particleElement.tickType();
        }
        return ParticleTickType.MOVE;
    }

    @Override
    public void tick(ParticleTickData particleTickData) {
        Location location = particleTickData.getLocation();

        Vector vector = new Vector(distance, 0, 0);
        vector.rotateAroundY((particleTickData.getDeg() * speed) % 360);
        ParticleTickData nParticleTickData = particleTickData.withLocation(location.clone().add(vector));
        particleElement.tick(nParticleTickData);

        vector.setX(-vector.getX());
        vector.setZ(-vector.getZ());

        nParticleTickData = particleTickData.withLocation(location.clone().add(vector));
        second.tick(nParticleTickData);
    }
}
